#!/usr/local/bin/perl -wT

#----------------------------------------------------------------
# Copyright (c) 2001 Benjamin Crowell, all rights reserved.
#
# This software is available under two different licenses: 
#  version 2 of the GPL, or
#  the Artistic License. 
# The software is copyrighted, and you must agree to one of
# these licenses in order to have permission to copy it. The full
# text of both licenses is given in the file titled Copying.
#
#----------------------------------------------------------------

use strict;

use lib "/home2/lightandmatter/www/cgi-bin/perl/lib/5.6.0/i386-linux";

use CGI;

#$| = 1; # Set output to flush directly (for troubleshooting)

#----------------------------------------------------------------
# Initialization
#----------------------------------------------------------------
$html::cgi = new CGI;
Url::decode_pars();


our $basic_file_name = "opengrade";
my $student = "";
if (Url::par_set("student")) {
  $student = Url::par("student");
}
my $dir = "";
if (Url::par_set("dir")) {
    $dir = Url::par("dir");
}
#----------------------------------------------------------------
# Contents of page.
#----------------------------------------------------------------
if (!$dir) {oh_no("no directory given")}

if (!($dir=~m/^[a-zA-Z0-9_\-\/]*$/) || length($dir)>50) {
      oh_no("illegal directory name");
}

if (!$student) {
  open(INDEX,"<$dir/index.html") or oh_no("error opening $dir/index.html");
  Html::PrintHTTPHeader();
  while (<INDEX>) {
      print;
  }
  close(INDEX);
}
else {
    my $cgi = new CGI;
    Html::PrintHTTPHeader();
    if (!($student=~m/^[a-zA-Z0-9_\-]*$/) || length($student)>50) {
      oh_no("illegal student name");
    }
    my $id = $cgi->param("id");
    if (!$id) {
	print $cgi->startform();
	print "<p>Please enter your password. If I have your student ID number, then\n";
	print "your password is the same as your student ID number (without the @ sign\n";
	print "in front). If that doesn't work, please e-mail me your student ID number.</p>\n";
	print $cgi->textfield(-name=>"id",-size=>"20");
	print $cgi->submit(-value=>"OK")."\n";
        print "</p>\n";
        print "\n".$cgi->endform."\n";
    }
    else {
        if (!($id=~m/^[a-zA-Z0-9_\-]*$/) || length($id)>50) {
          oh_no("illegal student id");
        }
        open(REPORT,"<$dir/$student.$id.html") or oh_no("incorrect password");
        while (<REPORT>) {
	    print;
	}
        close(REPORT);
	
    }
}

sub oh_no {
    my $mess = shift;
  Html::PrintHTTPHeader();
    print "<html><head><title>oh no!</title></head><body>$mess</body></html>\n";
    die;
}

#----------------------------------------------------------------
# Url class
#----------------------------------------------------------------
package Url;

our %params = ();

# Construct URL that links back to me. The DELETE
# arg tells which params to delete, written like "a"
# to delete a=xxx only, or "(a|b)" to delete more than one.
# If DELETE_ALL is used, then NOT_DELETE is the list
# not to delete, in the same style. Don't use DELETE and
# DELETE_ALL together.
sub link {
  my %args = (
    DELETE_ALL => 0,
    NOT_DELETE => "(what|debug|login|file)",
    DELETE => "",
    REPLACE => "",
    REPLACE_WITH => "",
    @_,
  );
    
  my $cgi = new CGI;
  my $this_script = $cgi->url(-relative=>1);
  
  # Workaround for a bug in CGI.pm: If GET and POST are both used, then
  # query_string only gives the javascript form stuff, not the URL stuff.
  #my $q = $cgi->query_string; # doesn't work
  my $q = "";
  my @u = $cgi->url_param;
  foreach my $a(@u) {
    if ($a ne "") {
      $q = $q . $a . "=" . $cgi->url_param($a) . "&"; # Extra & on the end gets cleaned up later
    }
  }
  
  # --- DELETE
  my $d = $args{DELETE};
  if ($d ne "") {
    $q =~ s/$d=[^=\&]*//g;
  }
  
  # --- DELETE_ALL
  if ($args{DELETE_ALL}) {
    my $nd = $args{NOT_DELETE};
    if ($nd eq "") {
      $q =~ s/[^=\&]+=[^=\&]*//g;
    }
    else {
      my $new = "";
      while ($q =~ m/($nd=[^=\&]*)/g) {
        $new = $new . $1 . "&";
      }
      $q = $new;
    }
  }
  
  # --- REPLACE
  my $r = $args{REPLACE};
  my $rw = $args{REPLACE_WITH};
  if ($r ne "") {
    if (!($q =~ m/$r/)) {$q=$q."&$r=$rw";}
    $q =~ s/$r=[^=\&]*/$r=$rw/;
  }
  
  # Tidy up.
  $q =~ s/\&\&+/\&/g; # replace && with &
  $q =~ s/\&+$//g; # strip & off the end
  
  return $this_script."?".$q;
}

sub par_is {
  my ($par,$val) = @_;
  return par($par) && $params{$par} eq $val;
}

sub par_set {
  my ($par) = @_;
  return exists($params{$par});
}

sub par {
  my ($par) = @_;
  return $params{$par};
}

sub report_pars {
  print "<p>Debugging output: list of GET method parameters:<br/>\n";
  foreach my $par(keys(%params)) {
    print "$par=".$params{$par}."<br/>\n";
  }
  print "</p>\n";
}

sub decode_pars {

	my $my_query_string = $ENV{'QUERY_STRING'};
	#my $my_query_string = "file=lm&what=check";
		
	my @query_key_pairs = split(/&/, $my_query_string);
	
	if (! @query_key_pairs) {return 0;}
	
	%params = ();
	foreach my $par (@query_key_pairs) {
	  my ($a,$b) = split(/=/, $par);
	  my ($aa,$bb,$msg);
	  $aa = $a;
	  $bb = $b;
	  #($aa,$msg) = Html::sanity_check(TEXT=>$a,MAX_LENGTH=>50);
	  #($bb,$msg) = Html::sanity_check(TEXT=>$b,MAX_LENGTH=>50);
	  $params{$aa} = $bb;
	}
}
#----------------------------------------------------------------
# Html package
#----------------------------------------------------------------
package Html;

sub PrintHTTPHeader
{
	#print "Content-type:text/html\n\n";
	#print "Content-type:text/plain\n\n";
	print "Pragma: no-cache\nCache-control: private\nContent-Type: text/html\n\n";


}


